# Class JSONObject

java.lang.Object
org.daypilot.json.JSONObject

public class JSONObject extends Object
A JSONObject is an unordered collection of name/value pairs. Its external form is a string wrapped in curly braces with colons between the names and values, and commas between the values and names. The internal form is an object having `get` and `opt` methods for accessing the values by name, and `put` methods for adding or replacing values by name. The values can be any of these types: `Boolean`, `JSONArray`, `JSONObject`, `Number`, `String`, or the `JSONObject.NULL` object. A JSONObject constructor can be used to convert an external form JSON text into an internal form whose values can be retrieved with the `get` and `opt` methods, or to convert values into a JSON text using the `put` and `toString` methods. A `get` method returns a value if one can be found, and throws an exception if one cannot be found. An `opt` method returns a default value instead of throwing an exception, and so is useful for obtaining optional values.

The generic `get()` and `opt()` methods return an object, which you can cast or query for type. There are also typed `get` and `opt` methods that do type checking and type coercion for you.

The `put` methods adds values to an object. For example,

         myString = new JSONObject().put("JSON", "Hello, World!").toString();

produces the string `{"JSON": "Hello, World"}`.

The texts produced by the `toString` methods strictly conform to the JSON syntax rules. The constructors are more forgiving in the texts they will accept:

- An extra `,` (comma) may appear just before the closing brace.
- Strings may be quoted with `'` (single quote).
- Strings do not need to be quoted at all if they do not begin with a quote or single quote, and if they do not contain leading or trailing spaces, and if they do not contain any of these characters: `{ } [ ] / \ : , = ; #` and if they do not look like numbers and if they are not the reserved words `true`, `false`, or `null`.
- Keys can be followed by `=` or `=>` as well as by `:`.
- Values can be followed by `;` (semicolon) as well as by `,` (comma).
- Numbers may have the `0-` (octal) or `0x-` (hex) prefix.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Object`
  `NULL`
  It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JSONObject()`
  Construct an empty JSONObject.
  `JSONObject(Object bean)`
  Construct a JSONObject from an Object using bean getters.
  `JSONObject(Object bean, boolean includeSuperClass)`
  Construct JSONObject from the given bean.
  `JSONObject(Object object, String[] names)`
  Construct a JSONObject from an Object, using reflection to find the public members.
  `JSONObject(String source)`
  Construct a JSONObject from a source JSON text string.
  `JSONObject(Map map)`
  Construct a JSONObject from a Map.
  `JSONObject(Map map, boolean includeSuperClass)`
  Construct a JSONObject from a Map.
  `JSONObject(JSONObject jo, String[] names)`
  Construct a JSONObject from a subset of another JSONObject.
  `JSONObject(JSONTokener x)`
  Construct a JSONObject from a JSONTokener.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `JSONObject`
  `accumulate(String key, Object value)`
  Accumulate values under a key.
  `JSONObject`
  `append(String key, Object value)`
  Append values to the array under a key.
  `static String`
  `doubleToString(double d)`
  Produce a string from a double.
  `Object`
  `get(String key)`
  Get the value object associated with a key.
  `boolean`
  `getBoolean(String key)`
  Get the boolean value associated with a key.
  `DateTime`
  `getDateTime(String key)`
  `double`
  `getDouble(String key)`
  Get the double value associated with a key.
  `int`
  `getInt(String key)`
  Get the int value associated with a key.
  `JSONArray`
  `getJSONArray(String key)`
  Get the JSONArray value associated with a key.
  `JSONObject`
  `getJSONObject(String key)`
  Get the JSONObject value associated with a key.
  `long`
  `getLong(String key)`
  Get the long value associated with a key.
  `static String[]`
  `getNames(Object object)`
  Get an array of field names from an Object.
  `static String[]`
  `getNames(JSONObject jo)`
  Get an array of field names from a JSONObject.
  `String`
  `getString(String key)`
  Get the string associated with a key.
  `boolean`
  `has(String key)`
  Determine if the JSONObject contains a specific key.
  `boolean`
  `isNull(String key)`
  Determine if the value associated with the key is null or if there is no value.
  `Iterator`
  `keys()`
  Get an enumeration of the keys of the JSONObject.
  `int`
  `length()`
  Get the number of keys stored in the JSONObject.
  `JSONArray`
  `names()`
  Produce a JSONArray containing the names of the elements of this JSONObject.
  `static String`
  `numberToString(Number n)`
  Produce a string from a Number.
  `Object`
  `opt(String key)`
  Get an optional value associated with a key.
  `boolean`
  `optBoolean(String key)`
  Get an optional boolean associated with a key.
  `boolean`
  `optBoolean(String key, boolean defaultValue)`
  Get an optional boolean associated with a key.
  `DateTime`
  `optDateTime(String key)`
  `double`
  `optDouble(String key)`
  Get an optional double associated with a key, or NaN if there is no such key or if its value is not a number.
  `double`
  `optDouble(String key, double defaultValue)`
  Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number.
  `int`
  `optInt(String key)`
  Get an optional int value associated with a key, or zero if there is no such key or if the value is not a number.
  `int`
  `optInt(String key, int defaultValue)`
  Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number.
  `JSONArray`
  `optJSONArray(String key)`
  Get an optional JSONArray associated with a key.
  `JSONObject`
  `optJSONObject(String key)`
  Get an optional JSONObject associated with a key.
  `long`
  `optLong(String key)`
  Get an optional long value associated with a key, or zero if there is no such key or if the value is not a number.
  `long`
  `optLong(String key, long defaultValue)`
  Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number.
  `String`
  `optString(String key)`
  Get an optional string associated with a key.
  `String`
  `optString(String key, String defaultValue)`
  Get an optional string associated with a key.
  `JSONObject`
  `put(String key, boolean value)`
  Put a key/boolean pair in the JSONObject.
  `JSONObject`
  `put(String key, double value)`
  Put a key/double pair in the JSONObject.
  `JSONObject`
  `put(String key, int value)`
  Put a key/int pair in the JSONObject.
  `JSONObject`
  `put(String key, long value)`
  Put a key/long pair in the JSONObject.
  `JSONObject`
  `put(String key, Object value)`
  Put a key/value pair in the JSONObject.
  `JSONObject`
  `put(String key, Collection value)`
  Put a key/value pair in the JSONObject, where the value will be a JSONArray which is produced from a Collection.
  `JSONObject`
  `put(String key, Map value)`
  Put a key/value pair in the JSONObject, where the value will be a JSONObject which is produced from a Map.
  `JSONObject`
  `putOnce(String key, Object value)`
  Put a key/value pair in the JSONObject, but only if the key and the value are both non-null, and only if there is not already a member with that name.
  `JSONObject`
  `putOpt(String key, Object value)`
  Put a key/value pair in the JSONObject, but only if the key and the value are both non-null.
  `static String`
  `quote(String string)`
  Produce a string in double quotes with backslash sequences in all the right places.
  `Object`
  `remove(String key)`
  Remove a name and its value, if present.
  `Iterator`
  `sortedKeys()`
  Get an enumeration of the keys of the JSONObject.
  `static Object`
  `stringToValue(String s)`
  Try to convert a string into a number, boolean, or null.
  `JSONArray`
  `toJSONArray(JSONArray names)`
  Produce a JSONArray containing the values of the members of this JSONObject.
  `String`
  `toString()`
  Make a JSON text of this JSONObject.
  `String`
  `toString(int indentFactor)`
  Make a prettyprinted JSON text of this JSONObject.
  `Writer`
  `write(Writer writer)`
  Write the contents of the JSONObject as JSON text to a writer.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### NULL

    public static final Object NULL
    It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value. `JSONObject.NULL.equals(null)` returns `true`. `JSONObject.NULL.toString()` returns `"null"`.

- ## Constructor Details

  - ### JSONObject

    public JSONObject()
    Construct an empty JSONObject.

  - ### JSONObject

    public JSONObject(JSONObject jo, String[] names) throws JSONException
    Construct a JSONObject from a subset of another JSONObject. An array of strings is used to identify the keys that should be copied. Missing keys are ignored.
    Parameters:
      `jo` - A JSONObject.
      `names` - An array of strings.
    Throws:
      `JSONException` - If a value is a non-finite number or if a name is duplicated.

  - ### JSONObject

    public JSONObject(JSONTokener x)
    Construct a JSONObject from a JSONTokener.
    Parameters:
      `x` - A JSONTokener object containing the source string.
    Throws:
      `JSONException` - If there is a syntax error in the source string or a duplicated key.

  - ### JSONObject

    public JSONObject(Map map)
    Construct a JSONObject from a Map.
    Parameters:
      `map` - A map object that can be used to initialize the contents of the JSONObject.

  - ### JSONObject

    public JSONObject(Map map, boolean includeSuperClass)
    Construct a JSONObject from a Map. Note: Use this constructor when the map contains invalid input: '<'key,bean>.
    Parameters:
      `map` - - A map with Key-Bean data.
      `includeSuperClass` - - Tell whether to include the super class properties.

  - ### JSONObject

    public JSONObject(Object bean)
    Construct a JSONObject from an Object using bean getters. It reflects on all of the public methods of the object. For each of the methods with no parameters and a name starting with `"get"` or `"is"` followed by an uppercase letter, the method is invoked, and a key and the value returned from the getter method are put into the new JSONObject. The key is formed by removing the `"get"` or `"is"` prefix. If the second remaining character is not upper case, then the first character is converted to lower case. For example, if an object has a method named `"getName"`, and if the result of calling `object.getName()` is `"Larry Fine"`, then the JSONObject will contain `"name": "Larry Fine"`.
    Parameters:
      `bean` - An object that has getter methods that should be used to make a JSONObject.

  - ### JSONObject

    public JSONObject(Object bean, boolean includeSuperClass)
    Construct JSONObject from the given bean. This will also create JSONObject for all internal object (List, Map, Inner Objects) of the provided bean. -- See Documentation of JSONObject(Object bean) also.
    Parameters:
      `bean` - An object that has getter methods that should be used to make a JSONObject.
      `includeSuperClass` - - Tell whether to include the super class properties.

  - ### JSONObject

    public JSONObject(Object object, String[] names)
    Construct a JSONObject from an Object, using reflection to find the public members. The resulting JSONObject's keys will be the strings from the names array, and the values will be the field values associated with those keys in the object. If a key is not found or not visible, then it will not be copied into the new JSONObject.
    Parameters:
      `object` - An object that has fields that should be used to make a JSONObject.
      `names` - An array of strings, the names of the fields to be obtained from the object.

  - ### JSONObject

    public JSONObject(String source)
    Construct a JSONObject from a source JSON text string. This is the most commonly used JSONObject constructor.
    Parameters:
      `source` - A string beginning with `{` (left brace) and ending with `}` (right brace).
    Throws:
      `JSONException` - If there is a syntax error in the source string or a duplicated key.

- ## Method Details

  - ### accumulate

    public JSONObject accumulate(String key, Object value) throws JSONException
    Accumulate values under a key. It is similar to the put method except that if there is already an object stored under the key then a JSONArray is stored under the key to hold all of the accumulated values. If there is already a JSONArray, then the new value is appended to it. In contrast, the put method replaces the previous value.
    Parameters:
      `key` - A key string.
      `value` - An object to be accumulated under the key.
    Returns:
      this.
    Throws:
      `JSONException` - If the value is an invalid number or if the key is null.

  - ### append

    public JSONObject append(String key, Object value) throws JSONException
    Append values to the array under a key. If the key does not exist in the JSONObject, then the key is put in the JSONObject with its value being a JSONArray containing the value parameter. If the key was already associated with a JSONArray, then the value parameter is appended to it.
    Parameters:
      `key` - A key string.
      `value` - An object to be accumulated under the key.
    Returns:
      this.
    Throws:
      `JSONException` - If the key is null or if the current value associated with the key is not a JSONArray.

  - ### doubleToString

    public static String doubleToString(double d)
    Produce a string from a double. The string "null" will be returned if the number is not finite.
    Parameters:
      `d` - A double.
    Returns:
      A String.

  - ### get

    public Object get(String key) throws JSONException
    Get the value object associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      The object associated with the key.
    Throws:
      `JSONException` - if the key is not found.

  - ### getBoolean

    public boolean getBoolean(String key)
    Get the boolean value associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      The truth.
    Throws:
      `JSONException` - if the value is not a Boolean or the String "true" or "false".

  - ### getDouble

    public double getDouble(String key) throws JSONException
    Get the double value associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      The numeric value.
    Throws:
      `JSONException` - if the key is not found or if the value is not a Number object and cannot be converted to a number.

  - ### getInt

    public int getInt(String key)
    Get the int value associated with a key. If the number value is too large for an int, it will be clipped.
    Parameters:
      `key` - A key string.
    Returns:
      The integer value.
    Throws:
      `JSONException` - if the key is not found or if the value cannot be converted to an integer.

  - ### getJSONArray

    public JSONArray getJSONArray(String key)
    Get the JSONArray value associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      A JSONArray which is the value.
    Throws:
      `JSONException` - if the key is not found or if the value is not a JSONArray.

  - ### getJSONObject

    public JSONObject getJSONObject(String key)
    Get the JSONObject value associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      A JSONObject which is the value.
    Throws:
      `JSONException` - if the key is not found or if the value is not a JSONObject.

  - ### getLong

    public long getLong(String key) throws JSONException
    Get the long value associated with a key. If the number value is too long for a long, it will be clipped.
    Parameters:
      `key` - A key string.
    Returns:
      The long value.
    Throws:
      `JSONException` - if the key is not found or if the value cannot be converted to a long.

  - ### getNames

    public static String[] getNames(JSONObject jo)
    Get an array of field names from a JSONObject.
    Returns:
      An array of field names, or null if there are no names.

  - ### getNames

    public static String[] getNames(Object object)
    Get an array of field names from an Object.
    Returns:
      An array of field names, or null if there are no names.

  - ### getString

    public String getString(String key)
    Get the string associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      A string which is the value.
    Throws:
      `JSONException` - if the key is not found.

  - ### has

    public boolean has(String key)
    Determine if the JSONObject contains a specific key.
    Parameters:
      `key` - A key string.
    Returns:
      true if the key exists in the JSONObject.

  - ### isNull

    public boolean isNull(String key)
    Determine if the value associated with the key is null or if there is no value.
    Parameters:
      `key` - A key string.
    Returns:
      true if there is no value associated with the key or if the value is the JSONObject.NULL object.

  - ### keys

    public Iterator keys()
    Get an enumeration of the keys of the JSONObject.
    Returns:
      An iterator of the keys.

  - ### length

    public int length()
    Get the number of keys stored in the JSONObject.
    Returns:
      The number of keys in the JSONObject.

  - ### names

    public JSONArray names()
    Produce a JSONArray containing the names of the elements of this JSONObject.
    Returns:
      A JSONArray containing the key strings, or null if the JSONObject is empty.

  - ### numberToString

    public static String numberToString(Number n) throws JSONException
    Produce a string from a Number.
    Parameters:
      `n` - A Number
    Returns:
      A String.
    Throws:
      `JSONException` - If n is a non-finite number.

  - ### opt

    public Object opt(String key)
    Get an optional value associated with a key.
    Parameters:
      `key` - A key string.
    Returns:
      An object which is the value, or null if there is no value.

  - ### optBoolean

    public boolean optBoolean(String key)
    Get an optional boolean associated with a key. It returns false if there is no such key, or if the value is not Boolean.TRUE or the String "true".
    Parameters:
      `key` - A key string.
    Returns:
      The truth.

  - ### optBoolean

    public boolean optBoolean(String key, boolean defaultValue)
    Get an optional boolean associated with a key. It returns the defaultValue if there is no such key, or if it is not a Boolean or the String "true" or "false" (case insensitive).
    Parameters:
      `key` - A key string.
      `defaultValue` - The default.
    Returns:
      The truth.

  - ### put

    public JSONObject put(String key, Collection value)
    Put a key/value pair in the JSONObject, where the value will be a JSONArray which is produced from a Collection.
    Parameters:
      `key` - A key string.
      `value` - A Collection value.
    Returns:
      this.
    Throws:
      `JSONException`

  - ### optDouble

    public double optDouble(String key)
    Get an optional double associated with a key, or NaN if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
    Parameters:
      `key` - A string which is the key.
    Returns:
      An object which is the value.

  - ### optDouble

    public double optDouble(String key, double defaultValue)
    Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
    Parameters:
      `key` - A key string.
      `defaultValue` - The default.
    Returns:
      An object which is the value.

  - ### optInt

    public int optInt(String key)
    Get an optional int value associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
    Parameters:
      `key` - A key string.
    Returns:
      An object which is the value.

  - ### optInt

    public int optInt(String key, int defaultValue)
    Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
    Parameters:
      `key` - A key string.
      `defaultValue` - The default.
    Returns:
      An object which is the value.

  - ### optJSONArray

    public JSONArray optJSONArray(String key)
    Get an optional JSONArray associated with a key. It returns null if there is no such key, or if its value is not a JSONArray.
    Parameters:
      `key` - A key string.
    Returns:
      A JSONArray which is the value.

  - ### optJSONObject

    public JSONObject optJSONObject(String key)
    Get an optional JSONObject associated with a key. It returns null if there is no such key, or if its value is not a JSONObject.
    Parameters:
      `key` - A key string.
    Returns:
      A JSONObject which is the value.

  - ### optLong

    public long optLong(String key)
    Get an optional long value associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
    Parameters:
      `key` - A key string.
    Returns:
      An object which is the value.

  - ### optLong

    public long optLong(String key, long defaultValue)
    Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
    Parameters:
      `key` - A key string.
      `defaultValue` - The default.
    Returns:
      An object which is the value.

  - ### optString

    public String optString(String key)
    Get an optional string associated with a key. It returns an empty string if there is no such key. If the value is not a string and is not null, then it is coverted to a string.
    Parameters:
      `key` - A key string.
    Returns:
      A string which is the value.

  - ### optString

    public String optString(String key, String defaultValue)
    Get an optional string associated with a key. It returns the defaultValue if there is no such key.
    Parameters:
      `key` - A key string.
      `defaultValue` - The default.
    Returns:
      A string which is the value.

  - ### put

    public JSONObject put(String key, boolean value)
    Put a key/boolean pair in the JSONObject.
    Parameters:
      `key` - A key string.
      `value` - A boolean which is the value.
    Returns:
      this.
    Throws:
      `JSONException` - If the key is null.

  - ### put

    public JSONObject put(String key, double value) throws JSONException
    Put a key/double pair in the JSONObject.
    Parameters:
      `key` - A key string.
      `value` - A double which is the value.
    Returns:
      this.
    Throws:
      `JSONException` - If the key is null or if the number is invalid.

  - ### put

    public JSONObject put(String key, int value)
    Put a key/int pair in the JSONObject.
    Parameters:
      `key` - A key string.
      `value` - An int which is the value.
    Returns:
      this.
    Throws:
      `JSONException` - If the key is null.

  - ### put

    public JSONObject put(String key, long value) throws JSONException
    Put a key/long pair in the JSONObject.
    Parameters:
      `key` - A key string.
      `value` - A long which is the value.
    Returns:
      this.
    Throws:
      `JSONException` - If the key is null.

  - ### put

    public JSONObject put(String key, Map value) throws JSONException
    Put a key/value pair in the JSONObject, where the value will be a JSONObject which is produced from a Map.
    Parameters:
      `key` - A key string.
      `value` - A Map value.
    Returns:
      this.
    Throws:
      `JSONException`

  - ### put

    public JSONObject put(String key, Object value)
    Put a key/value pair in the JSONObject. If the value is null, then the key will be removed from the JSONObject if it is present.
    Parameters:
      `key` - A key string.
      `value` - An object which is the value. It should be of one of these types: Boolean, Double, Integer, JSONArray, JSONObject, Long, String, or the JSONObject.NULL object.
    Returns:
      this.
    Throws:
      `JSONException` - If the value is non-finite number or if the key is null.

  - ### putOnce

    public JSONObject putOnce(String key, Object value) throws JSONException
    Put a key/value pair in the JSONObject, but only if the key and the value are both non-null, and only if there is not already a member with that name.
    Parameters:
      `key` -
      `value` -
    Returns:
      his.
    Throws:
      `JSONException` - if the key is a duplicate

  - ### putOpt

    public JSONObject putOpt(String key, Object value) throws JSONException
    Put a key/value pair in the JSONObject, but only if the key and the value are both non-null.
    Parameters:
      `key` - A key string.
      `value` - An object which is the value. It should be of one of these types: Boolean, Double, Integer, JSONArray, JSONObject, Long, String, or the JSONObject.NULL object.
    Returns:
      this.
    Throws:
      `JSONException` - If the value is a non-finite number.

  - ### quote

    public static String quote(String string)
    Produce a string in double quotes with backslash sequences in all the right places. A backslash will be inserted within invalid input: '<'/, allowing JSON text to be delivered in HTML. In JSON text, a string cannot contain a control character or an unescaped quote or backslash.
    Parameters:
      `string` - A String
    Returns:
      A String correctly formatted for insertion in a JSON text.

  - ### remove

    public Object remove(String key)
    Remove a name and its value, if present.
    Parameters:
      `key` - The name to be removed.
    Returns:
      The value that was associated with the name, or null if there was no value.

  - ### sortedKeys

    public Iterator sortedKeys()
    Get an enumeration of the keys of the JSONObject. The keys will be sorted alphabetically.
    Returns:
      An iterator of the keys.

  - ### stringToValue

    public static Object stringToValue(String s)
    Try to convert a string into a number, boolean, or null. If the string can't be converted, return the string.
    Parameters:
      `s` - A String.
    Returns:
      A simple JSON value.

  - ### toJSONArray

    public JSONArray toJSONArray(JSONArray names) throws JSONException
    Produce a JSONArray containing the values of the members of this JSONObject.
    Parameters:
      `names` - A JSONArray containing a list of key strings. This determines the sequence of the values in the result.
    Returns:
      A JSONArray of values.
    Throws:
      `JSONException` - If any of the values are non-finite numbers.

  - ### toString

    public String toString()
    Make a JSON text of this JSONObject. For compactness, no whitespace is added. If this would not result in a syntactically correct JSON text, then null will be returned instead.

    Warning: This method assumes that the data structure is acyclical.

    Overrides:
      `toString` in class `Object`
    Returns:
      a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).

  - ### toString

    public String toString(int indentFactor) throws JSONException
    Make a prettyprinted JSON text of this JSONObject.

    Warning: This method assumes that the data structure is acyclical.

    Parameters:
      `indentFactor` - The number of spaces to add to each level of indentation.
    Returns:
      a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
    Throws:
      `JSONException` - If the object contains an invalid number.

  - ### write

    public Writer write(Writer writer) throws JSONException
    Write the contents of the JSONObject as JSON text to a writer. For compactness, no whitespace is added.

    Warning: This method assumes that the data structure is acyclical.

    Returns:
      The writer.
    Throws:
      `JSONException`

  - ### getDateTime

    public DateTime getDateTime(String key)

  - ### optDateTime

    public DateTime optDateTime(String key)